/*************************************************************************/
//FileName : fpfdef.h
//Name : Kaku
//Copyright (C) 2004 - 2008 by ISHIZUE Design Automation Corp. All Right Reserved.
//Date :2008/12/23
/*************************************************************************/
#ifndef _FPFPROFILE_H_
#define _FPFPROFILE_H_

/*************************************************************************
 * PROTOTYPE
 *************************************************************************/
struct __pfl_UnitInfo;
struct __pfl_UnitInfo;

/*************************************************************************
 * GLOBAL FUNCTIONS
 *************************************************************************/
extern int    __PFL_START           (int (*)(int, char**), int, char**, int = 32);
extern void   __PFL_WATCH_ON        (int, const char*);
extern void   __PFL_WATCH_OFF       ();
extern bool   __PFL_IS_WATCHING     ();
extern void   __PFL_VAR_C_ADDR      (void*, void*);
extern void   __PFL_UNIT_DEBUG      (__pfl_UnitInfo *, double, double);
extern void   __PFL_LOOP            (int);
extern void   __PFL_LOOP_CNT        (int);
extern void   __PFL_BIND_STRUCT     (const char *, const char *,const char *, void *, int, void *, int, int);
extern void   __PFL_BIND_STRUCT     (int, void *, int, void *, int);
extern void   __PFL_BLOCK           (int);
extern void   __PFL_MAP_ADDR        (void *, void *);
extern void   ____PFL_GET_ADDR      (void *, void *);
extern bool  __PFL_ISNOT_OVERFLOWED ();

#define       __PFL_GET_ADDR(ptr1, ptr2)    ____PFL_GET_ADDR(&(ptr1), ptr2)

/*************************************************************************
 * MACRO
 *************************************************************************/
#define _nil(t)  ((t*)0)

/*************************************************************************
 * RAWNX
 *************************************************************************/
class __PFL_RAW {
public:
    __PFL_RAW() : madr(NULL) {
    }
    __PFL_RAW(const __PFL_RAW & _r) : madr(NULL) {
        
    }
    const __PFL_RAW & operator=(const __PFL_RAW & _r ) {
        return (*this);
    }
    void mmap( void * caddr ) {
        this->madr = (char *) caddr;
    }
    void * c_addr() {
        return ( (void*)this->madr );
    }
    char * madr;
};

/*************************************************************************
 * b{^\NX
 *************************************************************************/
template<class CT>
class __PFL_OBJECT {
    mutable __pfl_UnitInfo  * unit;     /* ւ̃IuWFNg */
    mutable CT              value;
    mutable CT              * shp;
    mutable bool            has_set;
public:
    __PFL_OBJECT();
    __PFL_OBJECT(const __PFL_OBJECT<CT> &);
    template<class T>
    __PFL_OBJECT(const __PFL_OBJECT<T> & obj) : unit(_nil(__pfl_UnitInfo)) {
        this->shp = &(this->value);
        *this->shp = obj.data();
        this->has_set = true;
    }
    __PFL_OBJECT(CT);
    virtual ~__PFL_OBJECT();
public:
    __PFL_OBJECT<CT> & operator=(CT);
    __PFL_OBJECT<CT> & operator=(const __PFL_OBJECT<CT> &);
    
    template<class T>
    __PFL_OBJECT<CT> & operator=(const __PFL_OBJECT<T> & obj)
    {
        this->set((CT)obj.data());
        return (*this);
    }
///////////////////////////////////////////////////////////////////////////////
//    void    bind(const char * fileName, const char * funcName,
//                 const char * varName, int lineNo,
//                 int initFlag, /* 0:none, 1:l, 2:tݒ */
//                 void * varShpAddr, int elemCnt = 0,
//                 int _signed = 2,
//                 int bitwidthLimit = -1, int f_msbLimit = 0, int f_lsbLimit = 0);
///////////////////////////////////////////////////////////////////////////////
    void    bind(int unitIndex, void * varShpAddr, int initFlag /* 0:none, 1:l, 2:tݒ */ );
    void    rec (int unitIndex);
    void    verify  (int unitIndex, void * varShpAddr);
    CT      data() const;           /* Q */
    operator    CT  () const;       /* {^LXg */
    CT *    c_addr  ();             /* C{^ւ̃|C^ */
    void    profile () const;       /* vt@CXV */
    void    set     (CT val);       /*  */
};
/*************************************************************************
 * RXgN^fXRXgN^
 *************************************************************************/
/* RXgN^\bh */
template<class CT> __PFL_OBJECT<CT>::__PFL_OBJECT() :
unit(_nil(__pfl_UnitInfo))
{
    this->shp = &(this->value);
    this->has_set = false;
}
/* RXgN^\bh */
template<class CT>
__PFL_OBJECT<CT>::__PFL_OBJECT(const __PFL_OBJECT<CT> & obj) :
unit(_nil(__pfl_UnitInfo))
{
    this->shp = &(this->value);
    this->set( (CT)obj.data() );
}
/* RXgN^\bh */
template<class CT> __PFL_OBJECT<CT>::__PFL_OBJECT(CT val):
unit(_nil(__pfl_UnitInfo))
{
    this->shp = &(this->value);
    this->set(val);
}
/* fXRXgN^ */
template<class CT> __PFL_OBJECT<CT>::~__PFL_OBJECT()
{
}

/*************************************************************************
 * Q
 *************************************************************************/
template<class CT> CT __PFL_OBJECT<CT>::data() const
{
    if( this->value != *this->shp || __PFL_IS_WATCHING() ) {
        if(NULL != unit)
        __PFL_UNIT_DEBUG(unit, this->value, *this->shp);
        /* OŕύXꂽ\邽 */
        this->value = *this->shp;
        this->has_set = true;
        this->profile();
    }
    return ( this->value );
}
template<class CT> __PFL_OBJECT<CT>::operator CT() const
{
    return ( data() );
}

/*************************************************************************
 * 
 *************************************************************************/
template<class CT> void __PFL_OBJECT<CT>::set(CT val)
{
    this->has_set = true;
    *this->shp   = val;
    this->value  = val;
    this->profile();
}
template<class CT>
__PFL_OBJECT<CT>& __PFL_OBJECT<CT>::operator=(CT val)
{
    this->set(val);
    return ( *this );
}
template<class CT>
__PFL_OBJECT<CT>& __PFL_OBJECT<CT>::operator=(const __PFL_OBJECT<CT> & obj)
{
    this->set(obj.data());
    return ( *this );
}

/*************************************************************************
 * f[^ւ̃|C^擾
 *************************************************************************/
template<class CT> CT * __PFL_OBJECT<CT>::c_addr()
{
    return ( shp );
}

/* ---- b̊{^\NX ---- */
typedef __PFL_OBJECT<char>                  PFL_C;
typedef __PFL_OBJECT<unsigned char>         PFL_UC;
typedef __PFL_OBJECT<short>                 PFL_S;
typedef __PFL_OBJECT<unsigned short>        PFL_US;
typedef __PFL_OBJECT<int>                   PFL_I;
typedef __PFL_OBJECT<unsigned int>          PFL_UI;
typedef __PFL_OBJECT<long long>             PFL_L;
typedef __PFL_OBJECT<unsigned long long>    PFL_UL;
typedef __PFL_OBJECT<float>                 PFL_F;
typedef __PFL_OBJECT<double>                PFL_D;

#endif // !_FPFPROFILE_H_

