/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfsim/fpfsim2.h,v $
 *           $Revision: 1.7 $
 *           $Date: 2010/03/15 08:21:17 $
 *           $Author: haru $
 *           $Log: fpfsim2.h,v $
 *           Revision 1.7  2010/03/15 08:21:17  haru
 *           *** empty log message ***
 *
 *           Revision 1.6  2009/12/28 12:39:17  haru
 *           *** empty log message ***
 *
 *           Revision 1.5  2009/07/31 09:24:40  haru
 *
 *           Add. dump trace info
 *
 *           Revision 1.4  2009/04/13 05:03:27  haru
 *
 *           Chg. marume job
 *
 *           Revision 1.3  2009/03/31 01:05:01  haru
 *
 *           Chg. mul calc
 *
 *           Revision 1.2  2009/03/03 10:00:40  haru
 *
 *           Chg. mul
 *           Add. math floor, ceil
 *           Chg. (1 << f_width) -> (1U << f_width)
 *
 *           Revision 1.1  2009/02/23 05:13:50  haru
 *
 *           new version
 *
 *           Revision 1.2  2008/11/28 07:25:48  haru
 *           first cvs modules.
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 
 * ԡ
 * ե̾fpfsim2.h
 *   ӥåȲϡʥߥ졼ѡ˥饹
 *==========================================================================*/

#ifndef _FPFFIXED_HPP_
#define _FPFFIXED_HPP_

#include "fpfsim2_int.h"

extern int __fpfsim_error;


/*************************************************************************
 * CLASS PROTOTYPE
 *************************************************************************/
class fpf_Fixed;
class fpf_UFixed;
class fpf_Int;
class fpf_UInt;

class __fpf_unit;

extern  double __fpfsim_EC_fixed2double( const fpf_Fixed &fx );
extern long long __fpfsim_EC_ExponToInt64Fixed( const fpf_Fixed &fx );

/*************************************************************************
 * ӥåå饹
 *************************************************************************/
class fpf_bwStack {
public :
    #define fpf_DEF_FIXED   0
    #define fpf_DEF_UFIXED  1
    #define fpf_DEF_INT     2
    #define fpf_DEF_UINT    3

    // constructor
    fpf_bwStack();

    // destructor
    ~fpf_bwStack();

    //
    void Push( fpf_Fixed *fx, int destVarNo );
    void Push( fpf_UFixed *fx, int destVarNo );
    void Push( fpf_Int *fx, int destVarNo );
    void Push( fpf_UInt *fx, int destVarNo );

    void Pop( fpf_Fixed *fx );
    void Pop( fpf_UFixed *fx );
    void Pop( fpf_Int *fx );
    void Pop( fpf_UInt *fx );

private :
    typedef struct _bwlist {
        int iType;
        void *pData;
        struct _bwlist *pNext;
    } _FPF_BWLIST;

    _FPF_BWLIST *bwList;
};

/*************************************************************************
 * 32ӥåȰո꾮
 *************************************************************************/
class fpf_Fixed {
    friend class fpf_UFixed;
    friend class fpf_Int;
    friend class fpf_UInt;

public:
    // constructor
    fpf_Fixed();
    fpf_Fixed( const double );
    fpf_Fixed( const fpf_Fixed &);
    fpf_Fixed( const fpf_UFixed &);
    fpf_Fixed( const fpf_Int &);
    fpf_Fixed( const fpf_UInt &);

    // destructor
    ~fpf_Fixed();

    // bind normal variable
    void bind(int varNo, char ov_mode, char rnd_mode, void* shp);
    // bind array variable
    void bind(int varNo, int array_size, 
                    char ov_mode, char rnd_mode, void *shp );

    // ԡ
    void copy( fpf_Fixed fx );
    void copy( fpf_UFixed fx );

    // ñ
    fpf_Fixed & operator = (const fpf_Fixed &);
    fpf_Fixed & operator = (const fpf_UFixed &);
    fpf_Fixed & operator = (const fpf_Int &);
    fpf_Fixed & operator = (const fpf_UInt &);

    fpf_Fixed & operator = (double);
    fpf_Fixed & operator = (float);
    fpf_Fixed & operator = (long double);
    fpf_Fixed & operator = (char);
    fpf_Fixed & operator = (unsigned char);
    fpf_Fixed & operator = (short);
    fpf_Fixed & operator = (unsigned short);
    fpf_Fixed & operator = (int);
    fpf_Fixed & operator = (unsigned int);
    fpf_Fixed & operator = (long);
    fpf_Fixed & operator = (unsigned long);
    fpf_Fixed & operator = (long long);
    fpf_Fixed & operator = (unsigned long long);

    // 㥹
    template <class CAST_TYPE>
    operator CAST_TYPE(){
            if( p_flag == FPF_P_FLAG_WAIT ){
                return (CAST_TYPE)fval;
            } else {
                if( this->ec_flag != 0 ){
                    return (CAST_TYPE)__fpfsim_EC_fixed2double( *this );
                }
                if( i_flag == 0 ){
                    return (CAST_TYPE)((double)ival / (1U << f_width));
                } else {    
                    return (CAST_TYPE)((double)ilval / (1LLU << f_width));
                }
            }
        }


    //
    // 黻
    //

    // ñ+
    fpf_Fixed operator + ();
    // ñ-
    fpf_Fixed operator - ();
    // ñ!
    int operator ! ();

    // û
    // fpf_Fixed + fpf_Fixed
    friend fpf_Fixed operator + (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed + fpf_Uixed
    friend fpf_Fixed operator + (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed + fpf_Int
    friend fpf_Fixed operator + (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed + fpf_UInt
    friend fpf_Fixed operator + (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed + A
    template <class TYPE>
    friend fpf_Fixed operator + (fpf_Fixed &left, TYPE val);
    // A + fpf_Fixed
    template <class TYPE>
    friend fpf_Fixed operator + (TYPE val, fpf_Fixed &right);

    // 
    // fpf_Fixed - fpf_Fixed
    friend fpf_Fixed operator - (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed - fpf_Uixed
    friend fpf_Fixed operator - (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed - fpf_Int
    friend fpf_Fixed operator - (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed - fpf_UInt
    friend fpf_Fixed operator - (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed - A
    template <class TYPE>
    friend fpf_Fixed operator - (fpf_Fixed &left, TYPE val);
    // A - fpf_Fixed
    template <class TYPE>
    friend fpf_Fixed operator - (TYPE val, fpf_Fixed &right);

    // 軻
    // fpf_Fixed * fpf_Fixed
    friend fpf_Fixed operator * (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed * fpf_Uixed
    friend fpf_Fixed operator * (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed * fpf_Int
    friend fpf_Fixed operator * (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed * fpf_UInt
    friend fpf_Fixed operator * (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed * A
    template <class TYPE>
    friend fpf_Fixed operator * (fpf_Fixed &left, TYPE val);
    // A * fpf_Fixed
    template <class TYPE>
    friend fpf_Fixed operator * (TYPE val, fpf_Fixed &right);

    // 
    // fpf_Fixed / fpf_Fixed
    friend fpf_Fixed operator / (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed / fpf_Uixed
    friend fpf_Fixed operator / (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed / fpf_Int
    friend fpf_Fixed operator / (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed / fpf_UInt
    friend fpf_Fixed operator / (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed / A
    template <class TYPE>
    friend double operator / (fpf_Fixed &left, TYPE val);
    // A / fpf_Fixed
    template <class TYPE>
    friend double operator / (TYPE val, fpf_Fixed &right);

    //  A < B
    // fpf_Fixed < fpf_Fixed
    friend int operator < (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed < fpf_Uixed
    friend int operator < (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed < fpf_Int
    friend int operator < (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed < fpf_UInt
    friend int operator < (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed < A
    template <class TYPE>
    friend int operator < (fpf_Fixed &left, TYPE val);
    // A < fpf_Fixed
    template <class TYPE>
    friend int operator < (TYPE val, fpf_Fixed &right);

    //  A <= B
    // fpf_Fixed <= fpf_Fixed
    friend int operator <= (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed <= fpf_Uixed
    friend int operator <= (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed <= fpf_Int
    friend int operator <= (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed <= fpf_UInt
    friend int operator <= (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed <= A
    template <class TYPE>
    friend int operator <= (fpf_Fixed &left, TYPE val);
    // A <= fpf_Fixed
    template <class TYPE>
    friend int operator <= (TYPE val, fpf_Fixed &right);

    //  A > B
    // fpf_Fixed > fpf_Fixed
    friend int operator > (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed > fpf_Uixed
    friend int operator > (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed > fpf_Int
    friend int operator > (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed > fpf_UInt
    friend int operator > (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed > A
    template <class TYPE>
    friend int operator > (fpf_Fixed &left, TYPE val);
    // A > fpf_Fixed
    template <class TYPE>
    friend int operator > (TYPE val, fpf_Fixed &right);

    //  A >= B
    // fpf_Fixed >= fpf_Fixed
    friend int operator >= (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed >= fpf_Uixed
    friend int operator >= (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed >= fpf_Int
    friend int operator >= (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed >= fpf_UInt
    friend int operator >= (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed >= A
    template <class TYPE>
    friend int operator >= (fpf_Fixed &left, TYPE val);
    // A >= fpf_Fixed
    template <class TYPE>
    friend int operator >= (TYPE val, fpf_Fixed &right);

    //  A == B
    // fpf_Fixed == fpf_Fixed
    friend int operator == (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed == fpf_Uixed
    friend int operator == (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed == fpf_Int
    friend int operator == (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed == fpf_UInt
    friend int operator == (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed == A
    template <class TYPE>
    friend int operator == (fpf_Fixed &left, TYPE val);
    // A == fpf_Fixed
    template <class TYPE>
    friend int operator == (TYPE val, fpf_Fixed &right);

    //  A != B
    // fpf_Fixed != fpf_Fixed
    friend int operator != (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed != fpf_Uixed
    friend int operator != (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed != fpf_Int
    friend int operator != (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed != fpf_UInt
    friend int operator != (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed != A
    template <class TYPE>
    friend int operator != (fpf_Fixed &left, TYPE val);
    // A != fpf_Fixed
    template <class TYPE>
    friend int operator != (TYPE val, fpf_Fixed &right);

    //  A && B
    // fpf_Fixed && fpf_Fixed
    friend int operator && (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed && fpf_Uixed
    friend int operator && (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed && fpf_Int
    friend int operator && (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed && fpf_UInt
    friend int operator && (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed && A
    template <class TYPE>
    friend int operator && (fpf_Fixed &left, TYPE val);
    // A && fpf_Fixed
    template <class TYPE>
    friend int operator && (TYPE val, fpf_Fixed &right);

    //  A || B
    // fpf_Fixed || fpf_Fixed
    friend int operator || (fpf_Fixed &left, fpf_Fixed &right);
    // fpf_Fixed || fpf_Uixed
    friend int operator || (fpf_Fixed &left, fpf_UFixed &right);
    // fpf_Fixed || fpf_Int
    friend int operator || (fpf_Fixed &left, fpf_Int &right);
    // fpf_Fixed || fpf_UInt
    friend int operator || (fpf_Fixed &left, fpf_UInt &right);

    // fpf_Fixed || A
    template <class TYPE>
    friend int operator || (fpf_Fixed &left, TYPE val);
    // A || fpf_Fixed
    template <class TYPE>
    friend int operator || (TYPE val, fpf_Fixed &right);

    // ǡμ
    double getFixedToDoubleValue();
    long long getFixed64Value();
    int getFixed32Value();
    // ǡΥå
    void assignDoubleData( double val );
    void assignInt32Data( int val, int s_f_width );
    void assignInt64Data( long long val, int s_f_width );
    void assignFpfFixed( const fpf_Fixed &fx );
    void assignUInt32Data( unsigned int val, int s_f_width );
    void assignUInt64Data( unsigned long long val, int s_f_width );
    void assignFpfUFixed( const fpf_UFixed &fx );

    // ؿɽ
    void EC_assignDoubleData( double val );
    void EC_assignInt64Data( long long val, int s_f_width );
    void EC_Add_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    void EC_Add_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    void EC_Add_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    void EC_Add_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    void EC_Add_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    void EC_Sub_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    void EC_Sub_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    void EC_Sub_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    void EC_Sub_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    void EC_Sub_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );

    int EC_Les_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_Les_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_Les_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    int EC_LesEq_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_LesEq_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_LesEq_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    int EC_Gre_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_Gre_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_Gre_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    int EC_GreEq_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_GreEq_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_GreEq_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    int EC_Equ_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_Equ_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_Equ_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );
    int EC_NotEqu_Fixed_Fixed( fpf_Fixed&, fpf_Fixed& );
    int EC_NotEqu_Fixed_Int( fpf_Fixed &left, fpf_Int &right );
    int EC_NotEqu_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right );

    void EC_Mul_Fixed_Fixed( fpf_Fixed &left, fpf_Fixed &right, int iMaxBitW );
    void EC_Mul_Fixed_Int( fpf_Fixed &left, fpf_Int &right, int iMaxBitW );
    void EC_Mul_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right, int iMaxBitW );
    void EC_Mul_Int_Fixed( fpf_Int &left, fpf_Fixed &right, int iMaxBitW );
    void EC_Mul_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right, int iMaxBitW );

    void EC_Div_Fixed_Fixed( fpf_Fixed &left, fpf_Fixed &right, int iMaxBitW );
    void EC_Div_Fixed_Int( fpf_Fixed &left, fpf_Int &right, int iMaxBitW );
    void EC_Div_Fixed_UInt( fpf_Fixed &left, fpf_UInt &right, int iMaxBitW );
    void EC_Div_Int_Fixed( fpf_Int &left, fpf_Fixed &right, int iMaxBitW );
    void EC_Div_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right, int iMaxBitW );



    // 黻ѿӥå
    void mkAddBitWidth( int i_width, int f_width, int p_flag, int add_bitw );

    // ɥɥ쥹μ
    void* getadr();
    // ɥǡǹ
    void FromShadowData( int setFlg );
    // ɥǡι
    void ToShadowData( int setFlg );
    // ؿΥݥб
    void bwPush( int var_no );
    void bwPop();
    // 黻ֹι
    void UpdateOpeNo( int ino );
    // ͡ǾͤΥå
    void SetMaxMinValue();
    // ͡ǾͤΥå
    void SetInitMaxMinValue();

    // ѿ
    int         varNo;      // ѿֹ
    char        p_flag;     // ե饰0ʤ̤
                            //             1ʤ꾮
                            //             2ʤ꾮Ѥ
    int         i_flag;     // 32 or 64 ӥåȻѥե饰 0:32ӥå 1:64ӥå
    double      fval;       // ưꥢ
    int         ival;       // 꾮ꥢ32ӥåȡ
    long long   ilval;      // 꾮ꥢ64ӥåȡ

    short       i_width;    // ӥå
    short       f_width;    // ӥå

    short       ec_flag;    // ؿ 1: 2:
    short       ec_bitw;    // ؿӥå

    int         ope_no;     // 黻No
    int         type;       // Υ
   __fpf_unit   *u;         // ơ֥륢ɥ쥹
    char        ov_mode;
    char        rnd_mode;

    int         init_flag;  // ǡե饰

    int         array_no;   // ֹ
    int         array_size; // 
private:
    void        *shp;       // ѿΰ 
                            // äƤκǽΥɥ쥹
    fpf_bwStack bw_stack;   // ݥ󥿼ΰ٤Υå
};

/*************************************************************************
 * 32ӥåȰʤ꾮
 *************************************************************************/

class fpf_UFixed {
    friend class fpf_Fixed;
    friend class fpf_Int;
    friend class fpf_UInt;

public:
    // constructor
    fpf_UFixed();
    fpf_UFixed( const double );
    fpf_UFixed( const fpf_UFixed & );
    fpf_UFixed( const fpf_Fixed & );
    fpf_UFixed( const fpf_Int & );
    fpf_UFixed( const fpf_UInt & );

    // destructor
    ~fpf_UFixed();

    // normal variable
    void bind(int varNo, char ov_mode, char rnd_mode, void *shp);
    // array variable
    void bind(int varNo, int array_size,
                char ov_mode, char rnd_mode, void *shp);

    // ԡ
    void copy( fpf_UFixed fx );
    void copy( fpf_Fixed fx );

    // ñ
    fpf_UFixed & operator = (const fpf_Fixed &);
    fpf_UFixed & operator = (const fpf_UFixed &);
    fpf_UFixed & operator = (const fpf_Int &);
    fpf_UFixed & operator = (const fpf_UInt &);

    fpf_UFixed & operator = (double);
    fpf_UFixed & operator = (float);
    fpf_UFixed & operator = (long double);
    fpf_UFixed & operator = (char);
    fpf_UFixed & operator = (unsigned char);
    fpf_UFixed & operator = (short);
    fpf_UFixed & operator = (unsigned short);
    fpf_UFixed & operator = (int);
    fpf_UFixed & operator = (unsigned int);
    fpf_UFixed & operator = (long);
    fpf_UFixed & operator = (unsigned long);
    fpf_UFixed & operator = (long long);
    fpf_UFixed & operator = (unsigned long long);

    // 㥹
    template <class CAST_TYPE>
    operator CAST_TYPE(){
            if( p_flag == FPF_P_FLAG_WAIT ){
                return (CAST_TYPE)fval;
            } else {
                if( i_flag == 0 ){
                    return (CAST_TYPE)((double)ival / (1U << f_width));
                } else {    
                    return (CAST_TYPE)((double)ilval / (1LLU << f_width));
                }
            }
        }

    //
    // 黻
    //

    // ñ+
    fpf_UFixed operator + ();
    // ñ-
    fpf_UFixed operator - ();
    // ñ!
    int operator ! ();

    // û
    // fpf_UFixed + fpf_UFixed
    friend fpf_UFixed operator + (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed + fpf_Fixed
    friend fpf_Fixed operator + (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed + fpf_Int
    friend fpf_Fixed operator + (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed + fpf_UInt
    friend fpf_UFixed operator + (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed + etc
    template <class TYPE>
    friend fpf_UFixed operator + (fpf_UFixed &left, TYPE val);
    // etc + fpf_UFixed
    template <class TYPE>
    friend fpf_UFixed operator + (TYPE val, fpf_UFixed &right);

    // 
    // fpf_UFixed - fpf_UFixed
    friend fpf_UFixed operator - (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed - fpf_Fixed
    friend fpf_Fixed operator - (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed - fpf_Int
    friend fpf_Fixed operator - (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed - fpf_UInt
    friend fpf_UFixed operator - (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed - etc
    template <class TYPE>
    friend fpf_UFixed operator - (fpf_UFixed &left, TYPE val);
    // etc - fpf_UFixed
    template <class TYPE>
    friend fpf_UFixed operator - (TYPE val, fpf_UFixed &right);

    // 軻
    // fpf_UFixed * fpf_UFixed
    friend fpf_UFixed operator * (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed * fpf_Fixed
    friend fpf_Fixed operator *  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed * fpf_Int
    friend fpf_Fixed operator * (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed * fpf_UInt
    friend fpf_UFixed operator * (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed * etc
    template <class TYPE>
    friend fpf_UFixed operator * (fpf_UFixed &left, TYPE val);
    // etc * fpf_UFixed
    template <class TYPE>
    friend fpf_UFixed operator * (TYPE val, fpf_UFixed &right);

    // 
    // fpf_UFixed / fpf_UFixed
    friend fpf_UFixed operator / (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed / fpf_Fixed
    friend fpf_Fixed operator /  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed / fpf_Int
    friend fpf_Fixed operator / (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed / fpf_UInt
    friend fpf_UFixed operator / (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed / etc
    template <class TYPE>
    friend double operator / (fpf_UFixed &left, TYPE val);
    // etc / fpf_UFixed
    template <class TYPE>
    friend double operator / (TYPE val, fpf_UFixed &right);

    //  A < B
    // fpf_UFixed < fpf_UFixed
    friend int operator < (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed < fpf_Fixed
    friend int operator <  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed < fpf_Int
    friend int operator < (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed < fpf_UInt
    friend int operator < (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed < etc
    template <class TYPE>
    friend int operator < (fpf_UFixed &left, TYPE val);
    // etc < fpf_UFixed
    template <class TYPE>
    friend int operator < (TYPE val, fpf_UFixed &right);

    //  A <= B
    // fpf_UFixed <= fpf_UFixed
    friend int operator <= (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed <= fpf_Fixed
    friend int operator <=  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed <= fpf_Int
    friend int operator <= (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed <= fpf_UInt
    friend int operator <= (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed <= etc
    template <class TYPE>
    friend int operator <= (fpf_UFixed &left, TYPE val);
    // etc <= fpf_UFixed
    template <class TYPE>
    friend int operator <= (TYPE val, fpf_UFixed &right);

    //  A > B
    // fpf_UFixed > fpf_UFixed
    friend int operator > (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed > fpf_Fixed
    friend int operator >  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed > fpf_Int
    friend int operator > (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed > fpf_UInt
    friend int operator > (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed > etc
    template <class TYPE>
    friend int operator > (fpf_UFixed &left, TYPE val);
    // etc > fpf_UFixed
    template <class TYPE>
    friend int operator > (TYPE val, fpf_UFixed &right);

    //  A >= B
    // fpf_UFixed >= fpf_UFixed
    friend int operator >= (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed >= fpf_Fixed
    friend int operator >=  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed >= fpf_Int
    friend int operator >= (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed >= fpf_UInt
    friend int operator >= (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed >= etc
    template <class TYPE>
    friend int operator >= (fpf_UFixed &left, TYPE val);
    // etc >= fpf_UFixed
    template <class TYPE>
    friend int operator >= (TYPE val, fpf_UFixed &right);

    //  A == B
    // fpf_UFixed == fpf_UFixed
    friend int operator == (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed == fpf_Fixed
    friend int operator ==  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed == fpf_Int
    friend int operator == (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed == fpf_UInt
    friend int operator == (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed == etc
    template <class TYPE>
    friend int operator == (fpf_UFixed &left, TYPE val);
    // etc == fpf_UFixed
    template <class TYPE>
    friend int operator == (TYPE val, fpf_UFixed &right);

    //  A != B
    // fpf_UFixed != fpf_UFixed
    friend int operator != (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed != fpf_Fixed
    friend int operator !=  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed != fpf_Int
    friend int operator != (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed != fpf_UInt
    friend int operator != (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed != etc
    template <class TYPE>
    friend int operator != (fpf_UFixed &left, TYPE val);
    // etc != fpf_UFixed
    template <class TYPE>
    friend int operator != (TYPE val, fpf_UFixed &right);

    //  A && B
    // fpf_UFixed && fpf_UFixed
    friend int operator && (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed && fpf_Fixed
    friend int operator &&  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed && fpf_Int
    friend int operator && (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed && fpf_UInt
    friend int operator && (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed && etc
    template <class TYPE>
    friend int operator && (fpf_UFixed &left, TYPE val);
    // etc && fpf_UFixed
    template <class TYPE>
    friend int operator && (TYPE val, fpf_UFixed &right);

    //  A || B
    // fpf_UFixed || fpf_UFixed
    friend int operator || (fpf_UFixed &left, fpf_UFixed &right);
    // fpf_UFixed || fpf_Fixed
    friend int operator ||  (fpf_UFixed &left, fpf_Fixed &right);
    // fpf_UFixed || fpf_Int
    friend int operator || (fpf_UFixed &left, fpf_Int &right);
    // fpf_UFixed || fpf_UInt
    friend int operator || (fpf_UFixed &left, fpf_UInt &right);

    // fpf_UFixed || etc
    template <class TYPE>
    friend int operator || (fpf_UFixed &left, TYPE val);
    // etc || fpf_UFixed
    template <class TYPE>
    friend int operator || (TYPE val, fpf_UFixed &right);

    // ǡμ
    double getFixedToDoubleValue();
    unsigned long long getFixed64Value();
    unsigned int getFixed32Value();
    // ǡΥå
    void assignDoubleData( double val );
    void assignInt32Data( int val, int s_f_width );
    void assignInt64Data( long long val, int s_f_width );
    void assignFpfFixed( const fpf_Fixed &fx );
    void assignUInt32Data( unsigned int val, int s_f_width );
    void assignUInt64Data( unsigned long long val, int s_f_width );
    void assignFpfUFixed( const fpf_UFixed &fx );
    // 黻ѿӥå
    void mkAddBitWidth( int i_width, int f_width, int p_flag, int add_bitw );

    // ɥɥ쥹μ
    void* getadr();
    // ɥǡǹ
    void FromShadowData( int setFlg );
    // ɥǡι
    void ToShadowData( int setFlg );
    // ؿΥݥб
    void bwPush( int var_no );
    void bwPop();
    // 黻ֹι
    void UpdateOpeNo( int ino );
    // ͡ǾͤΥå
    void SetMaxMinValue();

    // ѿ
    int         varNo;      // ѿֹ
    char        p_flag;     // ե饰0ʤ̤
                            //             1ʤ꾮
                            //             2ʤ꾮Ѥ
    int         i_flag;     // 32 or 64 ӥåȻѥե饰 0:32ӥå 1:64ӥå
    double      fval;       // ưꥢ
    unsigned int    ival;   // 꾮ꥢ
    unsigned long long ilval;  // 꾮ꥢ

    short       i_width;    // ӥå
    short       f_width;    // ӥå

    short       ec_flag;    // ؿ 1: 2:
    short       ec_bitw;    // ؿӥå

    int         ope_no;     // 黻ֹ
    int         type;       // Υ
    __fpf_unit  *u;         // ơ֥륢ɥ쥹
    char        ov_mode;
    char        rnd_mode;

    int         init_flag;  // ǡե饰

    int         array_no;   // ֹ
    int         array_size; // 
private:
    void        *shp;       // ѿΰ 
                            // äƤκǽΥɥ쥹
    fpf_bwStack bw_stack;   // ݥ󥿼ΰ٤Υå
};

/*************************************************************************
 * Ĥ
 *************************************************************************/
class fpf_Int {
    friend class fpf_Fixed;
    friend class fpf_UFixed;
    friend class fpf_UInt;

public:
    // constructor
    fpf_Int();
    fpf_Int( const double );
    fpf_Int( const fpf_Fixed &);
    fpf_Int( const fpf_UFixed &);
    fpf_Int( const fpf_Int &);
    fpf_Int( const fpf_UInt &);

    // destructor
    ~fpf_Int();

    // bind normal variable
    void bind(int varNo, char ov_mode, void* shp);
    // bind array variable
    void bind(int varNo, int array_size, char ov_mode, void *shp );

    // ԡ
    void copy( fpf_Int fx );
    void copy( fpf_UInt fx );

    // ñ
    fpf_Int & operator = (const fpf_Fixed &);
    fpf_Int & operator = (const fpf_UFixed &);
    fpf_Int & operator = (const fpf_Int &);
    fpf_Int & operator = (const fpf_UInt &);
    fpf_Int & operator = (double);
    fpf_Int & operator = (float);
    fpf_Int & operator = (long double);
    fpf_Int & operator = (char);
    fpf_Int & operator = (unsigned char);
    fpf_Int & operator = (short);
    fpf_Int & operator = (unsigned short);
    fpf_Int & operator = (int);
    fpf_Int & operator = (unsigned int);
    fpf_Int & operator = (long);
    fpf_Int & operator = (unsigned long);
    fpf_Int & operator = (long long);
    fpf_Int & operator = (unsigned long long);

    // 㥹
    template <class CAST_TYPE>
    operator CAST_TYPE() {
            if( i_flag == 0 ){
                return (CAST_TYPE)ival;
            } else {    
                return (CAST_TYPE)ilval;
            }
        }

    //
    // 黻
    //

    // ñ+
    fpf_Int operator + ();
    // ñ-
    fpf_Int operator - ();
    // ñ~
    fpf_Int operator ~ ();
    // ñ!
    int operator ! ();

    // û
    //  fpf_Int + fpf_Fixed
    friend fpf_Fixed operator + (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int + fpf_Uixed
    friend fpf_Fixed operator + (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int + fpf_Int
    friend fpf_Int operator + (fpf_Int &left, fpf_Int &right);
    //  fpf_Int + fpf_UInt
    friend fpf_Int operator + (fpf_Int &left, fpf_UInt &right);

#if(0)
    //  fpf_Int + A
    template <class TYPE>
    friend long long operator + (fpf_Int &left, TYPE val);
    //  A + fpf_Int
    template <class TYPE>
    friend long long operator + (TYPE val, fpf_Int &right);
#endif

    // 
    //  fpf_Int - fpf_Fixed
    friend fpf_Fixed operator - (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int - fpf_Uixed
    friend fpf_Fixed operator - (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int - fpf_Int
    friend fpf_Int operator - (fpf_Int &left, fpf_Int &right);
    //  fpf_Int - fpf_UInt
    friend fpf_Int operator - (fpf_Int &left, fpf_UInt &right);

#if(0)
    //  fpf_Int - A
    template <class TYPE>
    friend long long operator - (fpf_Int &left, TYPE val);
    //  A - fpf_Int
    template <class TYPE>
    friend long long operator - (TYPE val, fpf_Int &right);
#endif

    // 軻
    //  fpf_Int * fpf_Fixed
    friend fpf_Fixed operator * (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int * fpf_Uixed
    friend fpf_Fixed operator * (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int * fpf_Int
    friend fpf_Int operator * (fpf_Int &left, fpf_Int &right);
    //  fpf_Int * fpf_UInt
    friend fpf_Int operator * (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int * double
    template <class TYPE>
    friend double operator * (fpf_Int &left, double val);
    //  fpf_Int * A
    template <class TYPE>
    friend long long operator * (fpf_Int &left, TYPE val);
    //  double * fpf_Int
    template <class TYPE>
    friend double operator * (double val, fpf_Int &right);
    //  A * fpf_Int
    template <class TYPE>
    friend long long operator * (TYPE val, fpf_Int &right);

    // 
    //  fpf_Int / fpf_Fixed
    friend fpf_Fixed operator / (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int / fpf_Uixed
    friend fpf_Fixed operator / (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int / fpf_Int
    friend fpf_Int operator / (fpf_Int &left, fpf_Int &right);
    //  fpf_Int / fpf_UInt
    friend fpf_Int operator / (fpf_Int &left, fpf_UInt &right);

#if(0)
    //  fpf_Int / A
    template <class TYPE>
    friend long long operator / (fpf_Int &left, TYPE val);
    //  A / fpf_Int
    template <class TYPE>
    friend long long operator / (TYPE val, fpf_Int &right);
#endif

    // ;
    //  fpf_Int % fpf_Int
    friend long long operator % (fpf_Int &left, fpf_Int &right);
    //  fpf_Int % fpf_UInt
    friend long long operator % (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int % A
    template <class TYPE>
    friend long long operator % (fpf_Int &left, TYPE val);
    //  A % fpf_Int
    template <class TYPE>
    friend long long operator % (TYPE val, fpf_Int &right);

    //  A < B
    //  fpf_Int < fpf_Fixed
    friend int operator < (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int < fpf_Uixed
    friend int operator < (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int < fpf_Int
    friend int operator < (fpf_Int &left, fpf_Int &right);
    //  fpf_Int < fpf_UInt
    friend int operator < (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int < A
    template <class TYPE>
    friend int operator < (fpf_Int &left, TYPE val);
    //  A < fpf_Int
    template <class TYPE>
    friend int operator < (TYPE val, fpf_Int &right);

    //  A <= B
    //  fpf_Int <= fpf_Fixed
    friend int operator <= (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int <= fpf_Uixed
    friend int operator <= (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int <= fpf_Int
    friend int operator <= (fpf_Int &left, fpf_Int &right);
    //  fpf_Int <= fpf_UInt
    friend int operator <= (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int <= A
    template <class TYPE>
    friend int operator <= (fpf_Int &left, TYPE val);
    //  A <= fpf_Int
    template <class TYPE>
    friend int operator <= (TYPE val, fpf_Int &right);

    //  A > B
    //  fpf_Int > fpf_Fixed
    friend int operator > (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int > fpf_Uixed
    friend int operator > (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int > fpf_Int
    friend int operator > (fpf_Int &left, fpf_Int &right);
    //  fpf_Int > fpf_UInt
    friend int operator > (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int > A
    template <class TYPE>
    friend int operator > (fpf_Int &left, TYPE val);
    //  A > fpf_Int
    template <class TYPE>
    friend int operator > (TYPE val, fpf_Int &right);

    //  A >= B
    //  fpf_Int >= fpf_Fixed
    friend int operator >= (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int >= fpf_Uixed
    friend int operator >= (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int >= fpf_Int
    friend int operator >= (fpf_Int &left, fpf_Int &right);
    //  fpf_Int >= fpf_UInt
    friend int operator >= (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int >= A
    template <class TYPE>
    friend int operator >= (fpf_Int &left, TYPE val);
    //  A >= fpf_Int
    template <class TYPE>
    friend int operator >= (TYPE val, fpf_Int &right);

    //  A == B
    //  fpf_Int == fpf_Fixed
    friend int operator == (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int == fpf_Uixed
    friend int operator == (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int == fpf_Int
    friend int operator == (fpf_Int &left, fpf_Int &right);
    //  fpf_Int == fpf_UInt
    friend int operator == (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int == A
    template <class TYPE>
    friend int operator == (fpf_Int &left, TYPE val);
    //  A == fpf_Int
    template <class TYPE>
    friend int operator == (TYPE val, fpf_Int &right);

    //  A != B
    //  fpf_Int != fpf_Fixed
    friend int operator != (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int != fpf_Uixed
    friend int operator != (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int != fpf_Int
    friend int operator != (fpf_Int &left, fpf_Int &right);
    //  fpf_Int != fpf_UInt
    friend int operator != (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int != A
    template <class TYPE>
    friend int operator != (fpf_Int &left, TYPE val);
    //  A != fpf_Int
    template <class TYPE>
    friend int operator != (TYPE val, fpf_Int &right);

    //  A && B
    //  fpf_Int && fpf_Fixed
    friend int operator && (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int && fpf_Uixed
    friend int operator && (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int && fpf_Int
    friend int operator && (fpf_Int &left, fpf_Int &right);
    //  fpf_Int && fpf_UInt
    friend int operator && (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int && A
    template <class TYPE>
    friend int operator && (fpf_Int &left, TYPE val);
    //  A && fpf_Int
    template <class TYPE>
    friend int operator && (TYPE val, fpf_Int &right);

    //  A || B
    //  fpf_Int || fpf_Fixed
    friend int operator || (fpf_Int &left, fpf_Fixed &right);
    //  fpf_Int || fpf_Uixed
    friend int operator || (fpf_Int &left, fpf_UFixed &right);
    //  fpf_Int || fpf_Int
    friend int operator || (fpf_Int &left, fpf_Int &right);
    //  fpf_Int || fpf_UInt
    friend int operator || (fpf_Int &left, fpf_UInt &right);

    //  fpf_Int || A
    template <class TYPE>
    friend int operator || (fpf_Int &left, TYPE val);
    //  A || fpf_Int
    template <class TYPE>
    friend int operator || (TYPE val, fpf_Int &right);

    // ե A << B
    //  fpf_Int << fpf_Int
    friend long long operator << (fpf_Int &left, fpf_Int &right);
    //  fpf_Int << fpf_UInt
    friend long long operator << (fpf_Int &left, fpf_UInt &right);
    //  fpf_Int << A
    template <class TYPE>
    friend long long operator << (fpf_Int &left, TYPE val);
    //  A << fpf_Int
    template <class TYPE>
    friend long long operator << (TYPE val, fpf_Int &right);

    // ե A >> B
    //  fpf_Int >> fpf_Int
    friend fpf_Int operator >> (fpf_Int &left, fpf_Int &right);
    //  fpf_Int >> fpf_UInt
    friend fpf_Int operator >> (fpf_Int &left, fpf_UInt &right);
    //  fpf_Int >> A
    template <class TYPE>
    friend fpf_Int operator >> (fpf_Int &left, TYPE val);
    //  A >> fpf_Int
    template <class TYPE>
    friend long long operator >> (TYPE val, fpf_Int &right);

    // ӥåXOR A ^ B
    //  fpf_Int ^ fpf_Int
    friend long long operator ^ (fpf_Int &left, fpf_Int &right);
    //  fpf_Int ^ fpf_UInt
    friend long long operator ^ (fpf_Int &left, fpf_UInt &right);
    //  fpf_Int ^ A
    template <class TYPE>
    friend long long operator ^ (fpf_Int &left, TYPE val);
    //  A ^ fpf_Int
    template <class TYPE>
    friend long long operator ^ (TYPE val, fpf_Int &right);

    // ӥåAND A & B
    //  fpf_Int & fpf_Int
    friend long long operator & (fpf_Int &left, fpf_Int &right);
    //  fpf_Int & fpf_UInt
    friend long long operator & (fpf_Int &left, fpf_UInt &right);
    //  fpf_Int & A
    template <class TYPE>
    friend long long operator & (fpf_Int &left, TYPE val);
    //  A & fpf_Int
    template <class TYPE>
    friend long long operator & (TYPE val, fpf_Int &right);

    // ӥåOR A | B
    //  fpf_Int | fpf_Int
    friend long long operator | (fpf_Int &left, fpf_Int &right);
    //  fpf_Int | fpf_UInt
    friend long long operator | (fpf_Int &left, fpf_UInt &right);
    //  fpf_Int | A
    template <class TYPE>
    friend long long operator | (fpf_Int &left, TYPE val);
    //  A | fpf_Int
    template <class TYPE>
    friend long long operator | (TYPE val, fpf_Int &right);

    // ؿɽ黻
    int EC_Les_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    int EC_LesEq_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    int EC_Gre_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    int EC_GreEq_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    int EC_Equ_Int_Fixed( fpf_Int &left, fpf_Fixed &right );
    int EC_NotEqu_Int_Fixed( fpf_Int &left, fpf_Fixed &right );


    // ǡμ
    long long getInt64Value();
    int getInt32Value();
    // ǡΥå
    void assignDoubleData( double val );
    void assignInt32Data( int val );
    void assignInt64Data( long long val );
    void assignUInt32Data( unsigned int val );
    void assignUInt64Data( unsigned long long val );
    void assignFpfInt( const fpf_Int &fx );
    void assignFixedInt32Data( const fpf_Fixed &fx );
    void assignFixedInt64Data( const fpf_Fixed &fx );

    // 黻ѿӥå
    void mkAddBitWidth( int i_width, int add_bitw );

    // ɥɥ쥹μ
    void* getadr();
    // ɥǡǹ
    void FromShadowData( int setFlg );
    // ɥǡι
    void ToShadowData( int setFlg );
    // ؿΥݥб
    void bwPush( int var_no );
    void bwPop();
    // 黻ֹι
    void UpdateOpeNo( int ino );
    // ͡ǾͤΥå
    void SetMaxMinValue();

    int         varNo;      // ѿֹ
    int         i_flag;     // 32 or 64 ӥåȻѥե饰 0:32ӥå 1:64ӥå
    int         ival;       // ͡32ӥåȡ
    long long   ilval;      // ͡64ӥåȡ
    short       i_width;    // ӥå
    int         ope_no;     // 黻ֹ
    int         type;       // Υ
   __fpf_unit   *u;         // ơ֥륢ɥ쥹

    char        ov_mode;
    int         init_flag;  // ǡե饰

    int         array_no;   // ֹ
    int         array_size; // 
private:
    void        *shp;       // ѿΰ 
                            // äƤκǽΥɥ쥹
    fpf_bwStack bw_stack;   // ݥ󥿼ΰ٤Υå
};

/*************************************************************************
 * ʤ
 *************************************************************************/
class fpf_UInt {
    friend class fpf_Fixed;
    friend class fpf_UFixed;
    friend class fpf_Int;

public:
    // constructor
    fpf_UInt();
    fpf_UInt( const double );
    fpf_UInt( const fpf_Fixed &);
    fpf_UInt( const fpf_UFixed &);
    fpf_UInt( const fpf_UInt & );
    fpf_UInt( const fpf_Int & );

    // destructor
    ~fpf_UInt();

    // bind normal variable
    void bind(int varNo, char ov_mode, void* shp);
    // bind array variable
    void bind(int varNo, int array_size, char ov_mode, void *shp );

    // ԡ
    void copy( fpf_Int fx );
    void copy( fpf_UInt fx );

    fpf_UInt & operator = (const fpf_Fixed &);
    fpf_UInt & operator = (const fpf_UFixed &);
    fpf_UInt & operator = (const fpf_Int &);
    fpf_UInt & operator = (const fpf_UInt &);
    fpf_UInt & operator = (double);
    fpf_UInt & operator = (float);
    fpf_UInt & operator = (long double);
    fpf_UInt & operator = (char);
    fpf_UInt & operator = (unsigned char);
    fpf_UInt & operator = (short);
    fpf_UInt & operator = (unsigned short);
    fpf_UInt & operator = (int);
    fpf_UInt & operator = (unsigned int);
    fpf_UInt & operator = (long);
    fpf_UInt & operator = (unsigned long);
    fpf_UInt & operator = (long long);
    fpf_UInt & operator = (unsigned long long);

    // 㥹
    template <class CAST_TYPE>
    operator CAST_TYPE(){
            if( i_flag == 0 ){
                return (CAST_TYPE)ival;
            } else {    
                return (CAST_TYPE)ilval;
            }
        }

    //
    // 黻
    //

    // ñ+
    fpf_UInt operator + ();
    // ñ-
    fpf_UInt operator - ();
    // ñ~
    fpf_UInt operator ~ ();
    // ñ!
    int operator ! ();

    // û
    //  fpf_UInt + fpf_Fixed
    friend fpf_Fixed operator + (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt + fpf_Uixed
    friend fpf_UFixed operator + (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt + fpf_UInt
    friend fpf_UInt operator + (fpf_UInt &left, fpf_UInt &right);
    //  fpf_Int + fpf_Int
    friend fpf_Int operator + (fpf_UInt &left, fpf_Int &right);

#if(0) 
    //  fpf_UInt + A
    template <class TYPE>
    friend long long operator + (fpf_UInt &left, TYPE val);
    //  A + fpf_UInt
    template <class TYPE>
    friend long long operator + (TYPE val, fpf_UInt &right);
#endif

    // 
    //  fpf_UInt - fpf_Fixed
    friend fpf_Fixed operator - (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt - fpf_Uixed
    friend fpf_UFixed operator - (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt - fpf_UInt
    friend fpf_UInt operator - (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt - fpf_Int
    friend fpf_Int operator - (fpf_UInt &left, fpf_Int &right);

#if(0)
    //  fpf_UInt - A
    template <class TYPE>
    friend long long operator - (fpf_UInt &left, TYPE val);
    //  A - fpf_UInt
    template <class TYPE>
    friend long long operator - (TYPE val, fpf_UInt &right);
#endif

    // 軻
    //  fpf_UInt * fpf_Fixed
    friend fpf_Fixed operator * (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt * fpf_Uixed
    friend fpf_UFixed operator * (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt * fpf_UInt
    friend fpf_UInt operator * (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt * fpf_Int
    friend fpf_Int operator * (fpf_UInt &left, fpf_Int &right);

#if(0)
    //  fpf_UInt * double
    template <class TYPE>
    friend double operator * (fpf_UInt &left, double val);
    //  fpf_UInt * A
    template <class TYPE>
    friend long long operator * (fpf_UInt &left, TYPE val);
    //  double * fpf_UInt
    template <class TYPE>
    friend double operator * (double val, fpf_UInt &right);
    //  A * fpf_UInt
    template <class TYPE>
    friend long long operator * (TYPE val, fpf_UInt &right);
#endif

    // 
    //  fpf_UInt / fpf_Fixed
    friend fpf_Fixed operator / (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt / fpf_Uixed
    friend fpf_UFixed operator / (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt / fpf_UInt
    friend fpf_UInt operator / (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt / fpf_Int
    friend fpf_Int operator / (fpf_UInt &left, fpf_Int &right);

#if(0)
    //  fpf_UInt / A
    template <class TYPE>
    friend double operator / (fpf_UInt &left, TYPE val);
    //  A / fpf_UInt
    template <class TYPE>
    friend double operator / (TYPE val, fpf_UInt &right);
#endif

    // ;
    //  fpf_UInt % fpf_UInt
    friend long long  operator % (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt % fpf_Int
    friend long long operator % (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt % A
    template <class TYPE>
    friend long long operator % (fpf_UInt &left, TYPE val);
    //  A % fpf_UInt
    template <class TYPE>
    friend long long operator % (TYPE val, fpf_UInt &right);

    //  A < B 
    //  fpf_UInt < fpf_Fixed
    friend int operator < (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt < fpf_Uixed
    friend int operator < (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt < fpf_UInt
    friend int operator < (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt < fpf_Int
    friend int operator < (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt < A
    template <class TYPE>
    friend int operator < (fpf_UInt &left, TYPE val);
    //  A < fpf_UInt
    template <class TYPE>
    friend int operator < (TYPE val, fpf_UInt &right);

    //  A <= B
    //  fpf_UInt <= fpf_Fixed
    friend int operator <= (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt <= fpf_Uixed
    friend int operator <= (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt <= fpf_UInt
    friend int operator <= (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt <= fpf_Int
    friend int operator <= (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt <= A
    template <class TYPE>
    friend int operator <= (fpf_UInt &left, TYPE val);
    //  A <= fpf_UInt
    template <class TYPE>
    friend int operator <= (TYPE val, fpf_UInt &right);

    //  A > B
    //  fpf_UInt > fpf_Fixed
    friend int operator > (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt > fpf_Uixed
    friend int operator > (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt > fpf_UInt
    friend int operator > (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt > fpf_Int
    friend int operator > (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt > A
    template <class TYPE>
    friend int operator > (fpf_UInt &left, TYPE val);
    //  A > fpf_UInt
    template <class TYPE>
    friend int operator > (TYPE val, fpf_UInt &right);

    //  A >= B
    //  fpf_UInt >= fpf_Fixed
    friend int operator >= (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt >= fpf_Uixed
    friend int operator >= (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt >= fpf_UInt
    friend int operator >= (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt >= fpf_Int
    friend int operator >= (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt >= A
    template <class TYPE>
    friend int operator >= (fpf_UInt &left, TYPE val);
    //  A >= fpf_UInt
    template <class TYPE>
    friend int operator >= (TYPE val, fpf_UInt &right);

    //  A == B
    //  fpf_UInt == fpf_Fixed
    friend int operator == (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt == fpf_Uixed
    friend int operator == (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt == fpf_UInt
    friend int operator == (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt == fpf_Int
    friend int operator == (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt == A
    template <class TYPE>
    friend int operator == (fpf_UInt &left, TYPE val);
    //  A == fpf_UInt
    template <class TYPE>
    friend int operator == (TYPE val, fpf_UInt &right);

    //  A != B
    //  fpf_UInt != fpf_Fixed
    friend int operator != (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt != fpf_Uixed
    friend int operator != (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt != fpf_UInt
    friend int operator != (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt != fpf_Int
    friend int operator != (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt != A
    template <class TYPE>
    friend int operator != (fpf_UInt &left, TYPE val);
    //  A != fpf_UInt
    template <class TYPE>
    friend int operator != (TYPE val, fpf_UInt &right);

    //  A && B
    //  fpf_UInt && fpf_Fixed
    friend int operator && (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt && fpf_Uixed
    friend int operator && (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt && fpf_UInt
    friend int operator && (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt && fpf_Int
    friend int operator && (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt && A
    template <class TYPE>
    friend int operator && (fpf_UInt &left, TYPE val);
    //  A && fpf_UInt
    template <class TYPE>
    friend int operator && (TYPE val, fpf_UInt &right);

    //  A || B
    //  fpf_UInt || fpf_Fixed
    friend int operator || (fpf_UInt &left, fpf_Fixed &right);
    //  fpf_UInt || fpf_Uixed
    friend int operator || (fpf_UInt &left, fpf_UFixed &right);
    //  fpf_UInt || fpf_UInt
    friend int operator || (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt || fpf_Int
    friend int operator || (fpf_UInt &left, fpf_Int &right);

    //  fpf_UInt || A
    template <class TYPE>
    friend int operator || (fpf_UInt &left, TYPE val);
    //  A || fpf_UInt
    template <class TYPE>
    friend int operator || (TYPE val, fpf_UInt &right);

    // ե A << B
    //  fpf_UInt << fpf_UInt
    friend long long operator << (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt << fpf_Int
    friend long long operator << (fpf_UInt &left, fpf_Int &right);
    //  fpf_UInt << A
    template <class TYPE>
    friend long long operator << (fpf_UInt &left, TYPE val);
    //  A << fpf_UInt
    template <class TYPE>
    friend long long operator << (TYPE val, fpf_UInt &right);

    // ե A >> B
    //  fpf_UInt >> fpf_UInt
    friend fpf_UInt operator >> (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt >> fpf_Int
    friend fpf_UInt operator >> (fpf_UInt &left, fpf_Int &right);
    //  fpf_UInt >> A
    template <class TYPE>
    friend fpf_UInt operator >> (fpf_UInt &left, TYPE val);
    //  A >> fpf_UInt
    template <class TYPE>
    friend long long operator >> (TYPE val, fpf_UInt &right);

    // ӥåXOR A ^ B
    //  fpf_UInt ^ fpf_UInt
    friend long long operator ^ (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt ^ fpf_Int
    friend long long operator ^ (fpf_UInt &left, fpf_Int &right);
    //  fpf_UInt ^ A
    template <class TYPE>
    friend long long operator ^ (fpf_UInt &left, TYPE val);
    //  A ^ fpf_UInt
    template <class TYPE>
    friend long long operator ^ (TYPE val, fpf_UInt &right);

    // ӥåAND A & B
    //  fpf_UInt & fpf_UInt
    friend long long operator & (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt & fpf_Int
    friend long long operator & (fpf_UInt &left, fpf_Int &right);
    //  fpf_UInt & A
    template <class TYPE>
    friend long long operator & (fpf_UInt &left, TYPE val);
    //  A & fpf_UInt
    template <class TYPE>
    friend long long operator & (TYPE val, fpf_UInt &right);

    // ӥåOR A | B
    //  fpf_UInt | fpf_UInt
    friend long long operator | (fpf_UInt &left, fpf_UInt &right);
    //  fpf_UInt | fpf_Int
    friend long long operator | (fpf_UInt &left, fpf_Int &right);
    //  fpf_UInt | A
    template <class TYPE>
    friend long long operator | (fpf_UInt &left, TYPE val);
    //  A | fpf_UInt
    template <class TYPE>
    friend long long operator | (TYPE val, fpf_UInt &right);

    // ؿɽ黻
    int EC_Les_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    int EC_LesEq_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    int EC_Gre_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    int EC_GreEq_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    int EC_Equ_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );
    int EC_NotEqu_UInt_Fixed( fpf_UInt &left, fpf_Fixed &right );


    // doubleǡμ
    unsigned long long getInt64Value();
    unsigned int getInt32Value();
    // ǡΥå
    void assignDoubleData( double val );
    void assignInt32Data( int val );
    void assignInt64Data( long long val );
    void assignUInt32Data( unsigned int val );
    void assignUInt64Data( unsigned long long val );
    void assignFpfUInt( const fpf_UInt &fx );
    void assignFixedInt32Data( const fpf_Fixed &fx );
    void assignFixedInt64Data( const fpf_Fixed &fx );

    // 黻ѿӥå
    void mkAddBitWidth( int i_width, int add_bitw );

    // ɥɥ쥹μ
    void* getadr();
    // ɥǡǹ
    void FromShadowData( int setFlg );
    // ɥǡι
    void ToShadowData( int setFlg );
    // ؿΥݥб
    void bwPush( int var_no );
    void bwPop();
    // 黻ֹι
    void UpdateOpeNo( int ino );
    // ͡ǾͤΥå
    void SetMaxMinValue();

    int         varNo;      // ѿֹ
    int         i_flag;     // 32 or 64 ӥåȻѥե饰 0:32ӥå 1:64ӥå
    unsigned int ival;       // ͡32ӥåȡ
    unsigned long long ilval;      // ͡64ӥåȡ
    short       i_width;    // ӥå
    int         ope_no;     // 黻ֹ
    int         type;       // Υ
   __fpf_unit   *u;         // ơ֥륢ɥ쥹

    char        ov_mode;
    int         init_flag;  // ǡե饰
    int         array_no;   // ֹ
    int         array_size; // 
    int         iSgndFlg;   // 0:unsigned 1:sgnd  // add 091224
private:
    void        *shp;       // ѿΰ 
                            // äƤκǽΥɥ쥹
    fpf_bwStack bw_stack;   // ݥ󥿼ΰ٤Υå
};

#include "fpfsim_ope.h"
#include "fpfMath_sim.h"

extern int _FPFSIM_bwPush( fpf_Fixed *pFx, int iVarNo );
extern int _FPFSIM_bwPush( fpf_UFixed *pFx, int iVarNo );
extern int _FPFSIM_bwPusth( fpf_Int *pFx, int iVarNo );
extern int _FPFSIM_bwPush( fpf_UInt *pfx, int iVarNo );

extern int _FPFSIM_debug_open( char *pFileName );
extern void _FPFSIM_debug_close();
extern void _FPFSIM_debug_exp( int iCode,
    char *pResultName, char *pLeftName, char *pRightName,
    char *pFileName, int iSrcLine );
extern void _FPFSIM_debug_exp( int iCode,
    char *pResultName, char *pLeftName,
    char *pFileName, int iSrcLine );
extern void _FPFSIM_debug_exp(
    char *pResultName, char *pCondName, char *pLeftName, char *pRightName,
    char *pFileName, int iSrcLine );
extern void _FPFSIM_debug_asgn(
    char *pResultName, char *pLeftName,
    char *pFileName, int iSrcLine );
extern void _FPFSIM_debug_call(
    int stat, char *pResultName, char *pCallName,
    char *pFileName, int iSrcLine );
extern void _FPFSIM_debug_funcStart( char *pFuncName );
extern void _FPFSIM_debug_funcEnd();
extern int _FPFSIM_debug_var( fpf_Fixed *fx );
extern int _FPFSIM_debug_var( fpf_Int *fx );
extern int _FPFSIM_debug_var( fpf_UInt *fx );


extern int __fpf_readUInt( FILE *fp, fpf_UInt *pData );
extern int __fpf_readInt( FILE *fp, fpf_Int *pData );
extern int __fpf_readFixed( FILE *fp, fpf_Fixed *pData );

extern int __fpf_writeUInt( FILE *fp, fpf_UInt *pData );
extern int __fpf_writeInt( FILE *fp, fpf_Int *pData );
extern int __fpf_writeFixed( FILE *fp, fpf_Fixed *pData );

#define _FPF_DEF_BLOCK_MAX 15

extern int _fpf_block_manage[_FPF_DEF_BLOCK_MAX];
extern int _fpf_block_save[_FPF_DEF_BLOCK_MAX];
extern FILE *_fpf_block_fp[_FPF_DEF_BLOCK_MAX];

#endif // !_FPFFIXED_HPP_

